'use client';

// RULES:
// contains list page for lp_categories (QuizLPCategories)
// contain definition to collection only
//
import * as React from 'react';
import { useRouter } from 'next/navigation';
import { COL_LESSON_TYPES } from '@/constants';
import { LoadingButton } from '@mui/lab';
import Box from '@mui/material/Box';
import Card from '@mui/material/Card';
import Divider from '@mui/material/Divider';
import Stack from '@mui/material/Stack';
import Typography from '@mui/material/Typography';
import { Plus as PlusIcon } from '@phosphor-icons/react/dist/ssr/Plus';
import type { ListResult, RecordModel } from 'pocketbase';
import { useTranslation } from 'react-i18next';

import { paths } from '@/paths';
import { logger } from '@/lib/default-logger';
import { pb } from '@/lib/pb';
import { toast } from '@/components/core/toaster';
import ErrorDisplay from '@/components/dashboard/error';
import { defaultLessonType } from '@/components/dashboard/lesson_type/_constants';
import type { LessonType } from '@/components/dashboard/lesson_type/lesson-type';
import { LessonTypesFilters } from '@/components/dashboard/lesson_type/lesson-types-filters';
import type { Filters } from '@/components/dashboard/lesson_type/lesson-types-filters';
import { LessonTypesPagination } from '@/components/dashboard/lesson_type/lesson-types-pagination';
import { LessonTypesSelectionProvider } from '@/components/dashboard/lesson_type/lesson-types-selection-context';
import { LessonTypesTable } from '@/components/dashboard/lesson_type/lesson-types-table';
import FormLoading from '@/components/loading';

export default function Page({ searchParams }: PageProps): React.JSX.Element {
  const { t } = useTranslation(['lesson_type']);
  const { email, phone, sortDir, status, name, visible, type } = searchParams;
  const router = useRouter();
  const [lessonTypesData, setLessonTypesData] = React.useState<LessonType[]>([]);
  //

  const [isLoadingAddPage, setIsLoadingAddPage] = React.useState<boolean>(false);
  const [showLoading, setShowLoading] = React.useState<boolean>(true);
  const [showError, setShowError] = React.useState({ show: false, detail: '' });
  //
  const [rowsPerPage, setRowsPerPage] = React.useState<number>(5);
  const [f, setF] = React.useState<LessonType[]>([]);
  const [currentPage, setCurrentPage] = React.useState<number>(0);
  const [recordCount, setRecordCount] = React.useState<number>(0);
  const [listOption, setListOption] = React.useState({});
  const [listSort, setListSort] = React.useState({});

  //
  const reloadRows = async (): Promise<void> => {
    try {
      const models: ListResult<RecordModel> = await pb
        .collection(COL_LESSON_TYPES)
        .getList(currentPage + 1, rowsPerPage, listOption);
      const { items, totalItems } = models;
      const tempLessonTypes: LessonType[] = items.map((lt) => {
        return { ...defaultLessonType, ...lt };
      });

      setLessonTypesData(tempLessonTypes);
      setRecordCount(totalItems);
      setF(tempLessonTypes);
    } catch (error) {
      //
      logger.error(error);
      setShowError({ show: true, detail: JSON.stringify(error, null, 2) });
    } finally {
      setShowLoading(false);
    }
  };

  React.useEffect(() => {
    void reloadRows();
  }, [currentPage, rowsPerPage, listOption]);

  React.useEffect(() => {
    let tempFilter = [],
      tempSortDir = '';

    if (visible) {
      tempFilter.push(`visible = "${visible}"`);
    }

    if (sortDir) {
      tempSortDir = `-created`;
    }

    if (name) {
      tempFilter.push(`name ~ "%${name}%"`);
    }

    if (type) {
      tempFilter.push(`type ~ "%${type}%"`);
    }

    setListOption({
      filter: tempFilter.join(' && '),
      sort: tempSortDir,
      //
    });
  }, [visible, sortDir, name, type]);

  if (f.length === 0 || showLoading) return <FormLoading />;

  if (showError)
    return (
      <ErrorDisplay
        message={t('error.unable-to-process-request')}
        code="500"
        details={showError.detail}
      />
    );

  return (
    <Box
      sx={{
        maxWidth: 'var(--Content-maxWidth)',
        m: 'var(--Content-margin)',
        p: 'var(--Content-padding)',
        width: 'var(--Content-width)',
      }}
    >
      <Stack spacing={4}>
        <Stack
          direction={{ xs: 'column', sm: 'row' }}
          spacing={3}
          sx={{ alignItems: 'flex-start' }}
        >
          <Box sx={{ flex: '1 1 auto' }}>
            <Typography variant="h4">{t('list.title')}</Typography>
          </Box>
          <Box sx={{ display: 'flex', justifyContent: 'flex-end' }}>
            <LoadingButton
              loading={isLoadingAddPage}
              onClick={(): void => {
                setIsLoadingAddPage(true);
                router.push(paths.dashboard.lesson_types.create);
              }}
              startIcon={<PlusIcon />}
              variant="contained"
            >
              {/* add new lesson type */}
              {t('dashboard.lessonTypes.add')}
            </LoadingButton>
          </Box>
        </Stack>
        <LessonTypesSelectionProvider lessonTypes={f}>
          <Card>
            <LessonTypesFilters
              filters={{ email, phone, status, name, visible, type }}
              fullData={lessonTypesData}
              sortDir={sortDir}
              //
            />
            <Divider />
            <Box sx={{ overflowX: 'auto' }}>
              <LessonTypesTable
                reloadRows={reloadRows}
                rows={f}
                //
              />
            </Box>
            <Divider />
            <LessonTypesPagination
              count={recordCount}
              page={currentPage}
              rowsPerPage={rowsPerPage}
              setPage={setCurrentPage}
              setRowsPerPage={setRowsPerPage}
            />
          </Card>
        </LessonTypesSelectionProvider>
      </Stack>
    </Box>
  );
}

// Sorting and filtering has to be done on the server.

function applySort(row: LessonType[], sortDir: 'asc' | 'desc' | undefined): LessonType[] {
  return row.sort((a, b) => {
    if (sortDir === 'asc') {
      return a.createdAt.getTime() - b.createdAt.getTime();
    }

    return b.createdAt.getTime() - a.createdAt.getTime();
  });
}

function applyFilters(row: LessonType[], { email, phone, status, name, visible }: Filters): LessonType[] {
  return row.filter((item) => {
    if (email) {
      if (!item.email?.toLowerCase().includes(email.toLowerCase())) {
        return false;
      }
    }

    if (phone) {
      if (!item.phone?.toLowerCase().includes(phone.toLowerCase())) {
        return false;
      }
    }

    if (status) {
      if (item.status !== status) {
        return false;
      }
    }

    if (name) {
      if (!item.name?.toLowerCase().includes(name.toLowerCase())) {
        return false;
      }
    }

    if (visible) {
      if (!item.visible?.toLowerCase().includes(visible.toLowerCase())) {
        return false;
      }
    }

    return true;
  });
}

interface PageProps {
  searchParams: {
    email?: string;
    phone?: string;
    sortDir?: 'asc' | 'desc';
    status?: string;
    name?: string;
    visible?: string;
    type?: string;
    //
  };
}
